require 'libs/shapeData.lua'
require 'libs/class.lua'
require 'libs/vector.lua'

terrainChunk = class:new()
local terrainImg = love.graphics.newImage("art/terrain.png")

function terrainChunk:init(x, y, w, h)
	self.W = w
	self.H = h
	self.X = x
	self.Y = y
	self.s = {}
	
	self.blockNumW = (self.W/16) - 1
	self.blockNumH = (self.H/16) - 1
	
	--Creates 2d Array
	self.Squares = {}
	for i=1, self.blockNumW + 1 do
		self.Squares[i] = {}
	end
	
	--Fill 2d array with individual squares
	for i = 1, self.blockNumH + 1 do
		local tempY = self.Y-(8*self.blockNumH)+(i-1)*16
		for j = 1, self.blockNumW + 1 do
			local tempX = self.X-(8*self.blockNumW)+(j-1)*(16)
			----v--------------------------------------------v
			----v--------OFFENDING CODE BELOW----------------v
			----v--------------------------------------------v
			self.Squares[i][j] = terrainSquare:new(tempX,tempY)
			--^----------------------------------------------^
			--^----------OFFENDING CODE ABOVE----------------^
			--^----------------------------------------------^
		 end
	 end
end

function terrainChunk:setData()
	for m = 1, self.blockNumH + 1 do
		for t = 1, self.blockNumW + 1 do
			self.s[t][m]:setShape(self.s[t][m])
			self.s[t][m]:setBody(self.b[t][m])
		end
	end
	self.s:getData():setString("terrainChunk")
	self.s:getData():setObject(self)
	self.s:getData():setWidth(self.W)
	self.s:getData():setHeight(self.H)
end

function terrainChunk:update(dt)
end

function terrainChunk:draw()
		
	love.graphics.setColor(255,255,255,255)		
	
	for j = 1, self.blockNumH + 1 do
		local drawY = self.Y-(8*self.blockNumH)+(j-1)*(16)
		for i = 1, self.blockNumW + 1 do
			if not self.Squares[j][i].destroyed then
				love.graphics.draw(terrainImg, self.X-(8*self.blockNumW)+(i-1)*(16) - offsetX, drawY - offsetY, 0, 1, 1, 8, 8)
			end
		end
	end
	
end

function terrainChunk:getShape()
	return self.s
end

function terrainChunk:getBody()
	return self.b
end


