require 'libs/shapeData.lua'
require 'libs/class.lua'
require 'libs/vector.lua'

terrainSquare = class:new()


function terrainSquare:init(x, y)
	self.b = love.physics.newBody(world, x, y)
	self.s = love.physics.newRectangleShape(self.b, 0, 0, 16, 16)
	self.X = x
	self.Y = y
	self.destroyed = false
	
end

function terrainSquare:setData()
	self.s:setShape(self.s)
	self.s:setBody(self.b)
	self.s:getData():setString("terrainSquare")
	self.s:getData():setObject(self)
end

function terrainSquare:update(dt)
	if self.b then
		self.b:setPosition(self.b:getPosition() - offsetX)
		self.b:setPosition(self.b:getPosition() + offsetY)
	end
end

function terrainSquare:getShape()
	return self.s
end

function terrainSquare:getBody()
	return self.b
end

function terrainSquare:destroy()

	self.s:setMask(1)
	self.destroyed = true
	
end

