require 'entities/entList.lua'
require 'libs/mapList.lua'
require 'libs/shapeData.lua'
require 'libs/class.lua'
require 'libs/vector.lua'
require 'weapons.lua'

resW = 1024
resH = 1024

game = class:new()

function game:init()
	
	--World Creation
	world = love.physics.newWorld(-1024,-1024,1024,1024)
	world:setGravity(0, 300)
	world:setMeter(64)
	world:setCallbacks(add, persist, rem)
	
	--Inititialization	
	love.graphics.setBackgroundColor(0,0,0)
	love.graphics.setMode(resW, resH, false, true, 0)
	player_o = player:new( 64, 256 )
	
	--2d Array of chunks
	self.terrainMap = {}
	for i=1, 10 do
		self.terrainMap[i] = {}
	end
	
	-- for p=1, 1 do
		-- for o=1,   do
			-- self.terrainMap[o][p] = terrainChunk:new(256,512,512,512)
		-- end
	-- end
	
	t1 = terrainChunk:new(256,512,512,512)
	t2 = terrainChunk:new(512,512,512,512)
	
	love.mouse.setGrab(false)
	
	offsetX = 0
	offsetY = 0

end


function game:update(dt)
	
	--Information Updating
	world:update(dt)
	player_o:update(dt)
	
	t1:update(dt)
	t2:update(dt)
	
	-- for i=1, 1 do
		-- for j=1, 1 do
			-- self.terrainMap[i][j]:draw()
		-- end
	-- end	
	
	--Mouse Pos
	if love.keyboard.isDown("e") then
		pDebug(mouseX..","..mouseY, mouseX, mouseY)
	end
	
	if love.keyboard.isDown("escape") then
		--os.exit()
	end	
	
end

function game:mousepressed( x,y,button)

	--Destroy Individual Blocks
	if button == "l" then
		getClosest()
		closestObject:destroy()
	end
	
	if button == "r" then
		circularExplosion( x, y, 40 )
	end
		
end

function game:draw()	

	player_o:draw()		

	t1:draw()
	t2:draw()	
	-- for i=1, 1 do
		-- for j=1, 1 do
			-- self.terrainMap[i][j]:draw()
		-- end
	-- end	
	
end
	
