local View, LoveUI, super, geometry
local ClipView={}

function ClipView:load(lib)
	LoveUI=lib;
	View=LoveUI:require("View");
	super=View;
	super:subclass(self)
	return self;
end

function ClipView:init(frame)
	LoveUI.View.init(self, frame)
	self.offset={0, 0};
	self.opaque=true;
	return self;
end

function ClipView:getOffset()
	return self.__offset
end

function ClipView:addOffset(aPoint)
	aPoint.x=math.floor(aPoint.x)
	aPoint.y=math.floor(aPoint.y)
	
	for k, view in pairs(self.subviews) do
		view.frame[1]=view.frame[1]-self.__offset[1];
		view.frame[2]=view.frame[2]-self.__offset[2];
	end
	
	self.offset[1]=self.offset[1]+aPoint[1]
	self.offset[2]=self.offset[2]+aPoint[2]
	
	for k, view in pairs(self.subviews) do
		view.frame[1]=view.frame[1]+self.__offset[1];
		view.frame[2]=view.frame[2]+self.__offset[2];
	end
	self:calculateScissor();
end

function ClipView:setOffset(aPoint)
	aPoint[1]=math.floor(aPoint[1])
	aPoint[2]=math.floor(aPoint[2])
	
	for k, view in pairs(self.subviews) do
		view.frame[1]=view.frame[1]-self.__offset[1];
		view.frame[2]=view.frame[2]-self.__offset[2];
	end
	
	self.__offset=aPoint
	for k, view in pairs(self.subviews) do
		view.frame[1]=view.frame[1]+self.__offset[1];
		view.frame[2]=view.frame[2]+self.__offset[2];
	end
	
	self:calculateScissor();
end

function ClipView:addSubview(...)
	--table.insert(self.subviews, aView);
	for k, view in pairs({...}) do
		view.frame[1]=view.frame[1]+self.offset[1];
		view.frame[2]=view.frame[2]+self.offset[2];
	end
	LoveUI.View.addSubview(self, ...)
end

function ClipView:getContentSize()
	local rightestEdge, bottomestEdge=0, 0;
	for k, view in pairs(self.subviews) do
		if view.frame[1]+view.frame[3] > rightestEdge then
			rightestEdge=view.frame[1]+view.frame[3]
		end
		if view.frame[2]+view.frame[4] > bottomestEdge then
			bottomestEdge=view.frame[2]+view.frame[4]
		end
	end
	return {math.max(rightestEdge, self.frame[3]), math.max(bottomestEdge, self.frame[4])}
end

return ClipView

