----------------------------------------------------------------------------
-- Event is the super class of MouseEvent and KeyEvents.
-- Used to record input events.
----------------------------------------------------------------------------
local LoveUI, Object, super, Event= nil, nil, nil, {}

if type(module)=="function" then
	module (..., package.seeall)
end

----------------------------------------------------------------------------
-- Loads the Event class, automatically called when it's required by
-- LoveUI
-- @param lib table
-- @return class
----------------------------------------------------------------------------
function Event:load(lib)
	LoveUI=lib;
	Object=LoveUI:require("Object");
	super=Object;
	super:subclass(self);
	
	-- Event Constants
	Event.DEFAULT=1;
	Event.LEFT_MOUSE_UP=2;
	Event.LEFT_MOUSE_DOWN=3;
	Event.RIGHT_MOUSE_UP=4;
	Event.RIGHT_MOUSE_DOWN=5;
	Event.KEY_UP=6;
	Event.KEY_DOWN=7;
	Event.VALUE_CHANGED=8;
	return self;
end

----------------------------------------------------------------------------
-- Initializes the Event object
-- @param context Context
-- @param mouseLocation table
-- @param keysHeld table
-- @param time number
-- @return Event
----------------------------------------------------------------------------
function Event:init(context, mouseLocation, keysHeld, time)
	self.context=context;
	self.mouseLocation=mouseLocation
	self.keysHeld=keysHeld;
	self.time=time;
	return self;
end

return Event;