----------------------------------------------------------------------------
-- A MouseEvent records key presses and releases
----------------------------------------------------------------------------
local LoveUI, super, Event, KeyEvent= nil, nil, nil, {}

if type(module)=="function" then
	module (..., package.seeall)
end

----------------------------------------------------------------------------
-- Loads the KeyEvent class, automatically called when it's required by
-- LoveUI
-- @param lib table
-- @return class
----------------------------------------------------------------------------
function KeyEvent:load(lib)
	LoveUI=lib;
	Event=LoveUI:require("Event");
	super=Event;
	super:subclass(self);
	return self;
end

----------------------------------------------------------------------------
-- Initializes the KeyEvent object
-- @param context Context
-- @param keyCode number
-- @param unicodeKeyCode number
-- @param mouseLocation table
-- @param keysHeld table
-- @param time number
-- @return KeyEvent
----------------------------------------------------------------------------
function KeyEvent:init(context, keyCode, unicodeKeyCode, mouseLocation, keysHeld, time)
	super.init(self, context, mouseLocation, keysHeld, time);
	self.unicodeKeyCode=unicodeKeyCode;
	self.keyCode=keyCode;
	return self;
end

return KeyEvent;