----------------------------------------------------------------------------
-- A MouseEvent records mouse clicks
----------------------------------------------------------------------------
local LoveUI, super, Event, MouseEvent= nil, nil, nil, {}

if type(module)=="function" then
	module (..., package.seeall)
end

----------------------------------------------------------------------------
-- Loads the MouseEvent class, automatically called when it's required by
-- LoveUI
-- @param lib table
-- @return class
----------------------------------------------------------------------------
function MouseEvent:load(lib)
	LoveUI=lib;
	Event=LoveUI:require("Event");
	super=Event;
	super:subclass(self);
	return self;
end

----------------------------------------------------------------------------
-- Initializes the MouseEvent object
-- @param context Context
-- @param button number
-- @param mouseLocation table
-- @param keysHeld table
-- @param time number
-- @param clickCount number
-- @return MouseEvent
----------------------------------------------------------------------------
function MouseEvent:init(context, button, mouseLocation, keysHeld, time, clickCount)
	super.init(self, context, mouseLocation, keysHeld, time);
	self.clickCount=clickCount;
	self.button=button;
	return self;
end

return MouseEvent