require 'libs/class.lua'
menu = class:new()

function menu:init()
	
	self.items = {}
	self:addItem("Play Game")
	self:addItem("Quit")
	self.index = 1
	
end

function menu:update(dt)
end

function menu:draw()
	for i=1, #self.items do
		if i == self.index then
			love.graphics.setColor(64, 64, 64)
		else
			love.graphics.setColor(255, 255, 255)
		end
		love.graphics.print(self.items[i], 512, 512 + 32 * (i-1))
	end
end

function menu:addItem(text)
  self.items[#self.items + 1] = text
end

function menu:process()
	local text = self.items[self.index]
	if text == "Play Game" then
	  state = game:new()
	elseif text == "Quit" then
		os.exit()
	end
end

function menu:keypressed(key, unicode)
	if key == "up" then
		if self.index > 1 then
			self.index = self.index - 1
		end
	elseif key == "down" then
		if self.index < #self.items then
			self.index = self.index + 1
		end
	elseif key == "return" then
		self:process()
	end
end